package user

import "github.com/shopspring/decimal"

type AdminOrderAmountRequest struct {
	OpenId string `json:"openId"`
}

type AdminOrderAmountResponse struct {
	UserNum           int             `json:"userNum"`
	OrderNum          int             `json:"orderNum"`
	AdminAmount       decimal.Decimal `json:"adminAmount"`
	PlatformAmount    decimal.Decimal `json:"platformAmount"`
	AdminAmountSel    decimal.Decimal `json:"adminAmountSel"`
	PlatformAmountSel decimal.Decimal `json:"platformAmountSel"`
	AvailableAmount   decimal.Decimal `json:"availableAmount"`  //平台待结算金额--管理员可提现金额
	WithdrawalAmount  decimal.Decimal `json:"withdrawalAmount"` //平台已结算金额
}
