package user

import (
	"duoduo/models/mysql"

	"github.com/shopspring/decimal"
)

type TransGetInput struct {
	OpenId    string `json:"openId"`
	PidStatus int    `json:"pidStatus"`
}

type TransGetOutput struct {
	Wallet          mysql.Wallet    `json:"wallet"`
	ReviewAmount    decimal.Decimal `json:"reviewAmount"`    //审核中金额
	CompletedAmount decimal.Decimal `json:"completedAmount"` //审核完成金额
}
