package report

import "github.com/robfig/cron"

const (
	cronSettDateCutoff = "0 0 1 * * *"   //每天凌晨1:00:00
	cronRunStart       = "0 0 17 * * *"  //凌晨一点
	cronMinuteStart    = "0 */1 * * * *" //每分钟
	cronMinuteStart2   = "0 */2 * * * *" //每分钟
)

func SysCronStart() {
	c := cron.New()
	c.AddFunc(cronMinuteStart, OrderList)          //每分钟同步一下订单
	c.AddFunc(cronSettDateCutoff, AvailableAmount) //同步结算金额
	c.Start()
}
